// -- File: METRICS.CC

CLASS Metrics
/*
   ------------------------------------------------------------------
   Description:

      This class contains a set of routines to convert between
      various metrics ... this can be useful if you need to 
      change settings or convert settings between, say, twips
      and inches ...

   Programmers:

    Ken Mayer
 
    History: 

    01/30/1998 -- First version
 
    Instantiation:
 
    set procedure to metrics.cc additive
    oMyMetrics = new metrics()
 
    Typical usage would be to call individual methods from here,
    such as:
 
      ? oMyMetrics.Twips2Inches( nTwips )
 
    Methods:
       Inches2Twips
       Twips2Inches
       Points2Inches
       Inches2Points
       Twips2Points
       Points2Twips
       CM2Inches
       Inches2CM 
 
    Dependencies:
  
   ------------------------------------------------------------------
*/

   function Inches2Twips( nInches )
   return nInches * 1440

   function Twips2Inches( nTwips )
   return nTwips / 1440

   function Points2Inches( nPoints )
   return nPoints * 72

   function Inches2Points( nInches )
   return nInches / 72

   function Twips2Points( nTwips )
   return nTwips * 20

   function Points2Twips ( nPoints )
   return nPoints / 20

   function CM2Inches( nCM )
   return nCM * 2.54

   function Inches2CM( nInches )
   return nInches / 2.54


endclass