/*
   Minimum.prg
   Gary White
   July 20, 2001
   This is an enhanced version of the MIN() function
   in dBL. It will handle a list of parameters (rather
   than two which is what MIN() uses), or an array,
   and will return the smallest value.

   Note that no error checking for types is made in this 
   function. 

   Examples:

      ? Minimum( 1, 5, -1, 6 ) // should return -1
      ? Minimum( { 1, 5, -1, 6 } ) // should return -1
      a = { 1, 5, -1, 6 } // literal array
      ? Minimum( a ) // should return -1
      a = new array()
      a.add( 1 )
      a.add( 5 )
      a.add( -1 )
      a.add( 6 )
      ? Minimum( a ) // should return -1
*/

function Minimum
   local bRet, i
   bRet = 2 ^ 256
   if type('argvector(1)') == 'A'
   	for i = 1 to argvector(1).size
          bRet = min(bRet, argvector(1)[i])
      next
   else
   	for i = 1 to argCount()
          bRet = min(bRet, argVector(i))
      next
   endif
return bRet
// End of function: Minimum()
