/*
   --------------------------------------------------------------//
   Filename....: Translator.cc
   ClassName...: TForm
   Purpose.....: Translation Defination of all forms 
   Programmer..: Jonny Kwekkeboom
                 based on Paul White's Translation.cc
   Date........: March 15, 2003
   Notes.......: Beginning with dBASE PLUS 2.02 this object
   Written for.: dB2K and dBASE PLUS 2.01 and newer
   Rev. History: None
   Dependencies: Language.dbf Language.mdx 
                 BDE ALIAS NAME where Language.dbf will be find...

   Called......: _app.BDEAliasName = "DUFLP" //BDE Alias where Language.dbf will be found
                 or
                 _app.BDEAliasName = NULL //for NO ALIAS

                 _app.transLang = _app.Language //for dBase defaults
                 or 
                 _app.transLang = "FR" //france
                 _app.transLang = "HU" //hungarian
                 _app.transLang = "NL" //Dutch
                 _app.transLang = "PO" //Polish
                 _app.transLang = "RU" //Russian
                 _app.transLang = "PB" //Portuguese (Brazil)
                 _app.transLang = "CZ" //Czech
                 _app.transLang = "RO" //Romanian
                 _app.transLang = "ROD" //Romanian (Diacritics)

                 based on this.TR_Work Array !!!

                 Set procedure to Translator,cc additive

   Example.....: 

      msgbox(TFORM::Trans("Your message here",TFORM::Trans("Information"),64)
      form.Text1.text = TFORM::Trans("Your Text here")
      form.Pushbutton1.text = TFORM::Trans("Your Button text here")
      and so on...

      For translate all Text inside form better is to set a
      function Set_lang for do this in the Open of the form.

      Like:
      function Open
         class::INIT( )      
      return(SUPER::OPEN( ))

      function ReadModal
         class::INIT( )      
      return(SUPER::READMODAL( ))

      function INIT
         _app.transLang = _app.Language //for dBase defaults
         _app.BDEAliasName = "DUFLP"
         set procedure to Translator.cc additive
         class::set_lang()

      function Set_lang()
         with( form )
             Text1.text       = TFORM::Trans("Your Text here")
             Pushbutton1.text = TFORM::Trans("Your Buttontext here")
             ... and so on ...
         endwith

      This can also stream in by Design_onOpen for check the len
      of the translator text inside the form

      Like:
      ...
      class YOURForm of FORM
         onDesignOpen = class::DESIGN_ONOPEN
      ...

      function DESIGN_ONOPEN
          _app.transLang = "DE"  //for german text out of Language.dbf
          set procedure to Translator.cc additive
          class::set_lang()


      if the text will be not found inside the Language.dbf file
      so it will automatical add inside the DBF and can
      be translated after all work is done in the right fields...

      The maximal Text lenght can be 508 Chars for good work...
      It can also be splitted like:
      msgbox(TFORM::Trans("The first 508 Chars");
             +TFORM::Trans("The rest of text")....

      For msgboxes can also be work with %1 for including 
      informations with Stuff

      Like:

      Local cText
         cText = TFORM::Trans("The file: %1 will be not found")
         cText = STUFF(cText,AT("%1",cText),2,":DFULP:Language.mdx")
         msgbox(cText,TFORM::Trans("Attention"),16)
                 
   --------------------------------------------------------------//
   */
#ifndef TFORM_H
#define TFORM_H

class TForm(parentObj) of this(parentObj)
//for the translation this.TR_Work Array (Defaults)
#define TR_DE    1  //german DE
#define TR_IT    2  //italian IT
#define TR_ES    3  //Spain ES
#define TR_FR    4  //France FR
#define TR_HU    5  //Hungarian HU
#define TR_PO    6  //Polish PO
#define TR_PB    7  //Portuguese (Brazil) PB
#define TR_JA    8  //Japan JA
#define TR_NL    9  //Dutch NL
#define TR_RO   10  //Romanian RO
#define TR_ROD  11  //Romanian (Diacritics) ROD
#define TR_CZ   12  //Czech CZ
#define TR_RU   13  //Russian RU
** Set allways at last
#define TR_EN   14  //English EN

  function Trans
  Parameter qCT       
      if empty( qCT )
        return( "" )
      endif
      Privat cRet             
      Local qT, qL, qTR_i,qCTRett

      qCTRett = qCT
      if type("this.TR_Work") = "U"
         *** Translations of ScriptMaker definations 
         this.TR_Work = new Array(TR_EN,3)
         this.TR_Work.fill("")
         this.TR_Work[TR_DE,1] = "DE"     //Country Def
         this.TR_Work[TR_DE,2] = "German" //Country name for Display if wanted inside Menuitems...
         this.TR_Work[TR_DE,3] = "german" //Fieldname in Language.dbf file
         
         this.TR_Work[TR_IT,1] = "IT"
         this.TR_Work[TR_IT,2] = "Italian"
         this.TR_Work[TR_IT,3] = "italian"
         
         this.TR_Work[TR_ES,1] = "ES"
         this.TR_Work[TR_ES,2] = "Spain"
         this.TR_Work[TR_ES,3] = "spanish"
         
         this.TR_Work[TR_FR,1] = "FR"
         this.TR_Work[TR_FR,2] = "France"
         this.TR_Work[TR_FR,3] = "french"
         

         this.TR_Work[TR_HU,1] = "HU"
         this.TR_Work[TR_HU,2] = "Hungarian"
         this.TR_Work[TR_HU,3] = "hungarian"
         

         this.TR_Work[TR_PO,1] = "PO"
         this.TR_Work[TR_PO,2] = "Polish"
         this.TR_Work[TR_PO,3] = "polish"
         

         this.TR_Work[TR_PB,1] = "PB"
         this.TR_Work[TR_PB,2] = "Portuguese (Brazil)"
         this.TR_Work[TR_PB,3] = "portuguese_brazil"
         
         this.TR_Work[TR_JA,1] = "JA"
         this.TR_Work[TR_JA,2] = "Japan"
         this.TR_Work[TR_JA,3] = "japan"
         

         this.TR_Work[TR_NL,1] = "NL"
         this.TR_Work[TR_NL,2] = "Netherland"
         this.TR_Work[TR_NL,3] = "dutch"
         

         this.TR_Work[TR_RO,1] = "RO"
         this.TR_Work[TR_RO,2] = "Romanian"
         this.TR_Work[TR_RO,3] = "romanian"
         

         this.TR_Work[TR_ROD,1] = "ROD"
         this.TR_Work[TR_ROD,2] = "Romanian (Diacritics)"
         this.TR_Work[TR_ROD,3] = "romanian_diacritics"
         
         this.TR_Work[TR_CZ,1] = "CZ"
         this.TR_Work[TR_CZ,2] = "Czech"
         this.TR_Work[TR_CZ,3] = "czech"
         

         this.TR_Work[TR_RU,1] = "RU"
         this.TR_Work[TR_RU,2] = "Russian"
         this.TR_Work[TR_RU,3] = "russian"
         

         this.TR_Work[TR_EN,1] = "EN"
         this.TR_Work[TR_EN,2] = "English"
         this.TR_Work[TR_EN,3] = "english"         
      endif

      if type( "_app.BDEAliasName" ) == "U"
         _app.BDEAliasName = NULL
      endif     
      ****************

      if type( "_app.TranslatorQ" ) <> "O"
         if _app.BDEAliasName # NULL      
            _app.TransDatabase.active  = false      
            _app.TransDatabase                = new DATABASE()
            _app.TransDatabase.databaseName   = _app.BDEAliasName
            _app.TransDatabase.active = true
         endif

         try
           _app.TranslatorQ.active           = false
         catch(exception e)
         endtry
         _app.TranslatorQ                  = new Query( )
         if _app.BDEAliasName # NULL
            _app.translatorQ.database         = _app.TransDatabase
         endif
         _app.translatorQ.sql              = "select * from 'language.dbf'"
         _app.translatorQ.active           = true
         _app.translatorQ.rowset.indexname = "allind"
      endif

      oQ = _app.TranslatorQ
      qL = oQ.Rowset.Fields["allind"].length
      qT = left( qCT + space( qL ), qL )
      
      if not oQ.rowset.findkey( qT )
        do while len(qCT) > 0
           oQ.rowset.BeginAppend( )
           oQ.rowset.fields["allind"].value = qT

           //save if not found in Default Language ENGLISH field !!
           //this can changed by right fieldName of your language 
           //for save in right fieldname your Langauge!!!!
           oQ.rowset.fields["english"].value = Iif( len(qCT) > 254,substr(qCT,1,254),qCT )

           oQ.rowset.fields["splitt"].value  = false //not longer than 254 chars..
           IF len(qCT) > 254
              qCT = substr(qCT,255)
              qT = left( qCT + space( qL ), qL )
              oQ.rowset.fields["splitt"].value = true //longer than 254 Chars!          
              IF len(qCT) > 254
                 msgbox("Translator Error String > 508 chars!!"+cr+cr+"Will truncated to 508 chars!","Attention",16)
                 qCT = substr(qCT,1,254)
              ENDIF
           ELSE
              qCT = ""
           ENDIF
           oQ.Rowset.Save( )           
        enddo
        cRet = qCT
        if empty(cRet)
           cRet = qCTRett
        endif
        return(Iif( left( cRet.toUppercase( ),1 ) == "W"," "+rtrim( cRet ),rtrim( cRet  ) ))       
      endif

      for qTR_i = 1 to Alen( this.TR_Work,1 )
          //loop thru all defined languages inside of H_INIT.cc
          IF _app.transLang == this.TR_Work[qTR_i,1]
             cRet = "oQ.Rowset.Fields[" + '"' + this.TR_Work[qTR_i,3] + '"' + "].value"
             try
               cRet = &cRet
               if empty(cRet)
                  //than set to default english language TR_EN
                  cRet = "oQ.Rowset.Fields[" + '"' + this.TR_Work[TR_EN,3] + '"' + "].value"
                  try
                    cRet = &cRet                    
                  catch( exception e )
                    msgbox( e.message + cr + "Errorcode: Trans1 (Line: " + e.lineno + ")" )
                    return( "" )
                  endtry
               endif
               if empty(cRet)
                  //than set to default programmers language  (german TR_DE)
                  cRet = "oQ.Rowset.Fields[" + '"' + this.TR_Work[TR_DE,3] + '"' + "].value"
                  try
                    cRet = &cRet
                  catch( exception e )
                    msgbox( e.message + cr + "Errorcode: Trans3 (Line: " + e.lineno + ")" )
                    return( "" )
                  endtry
               endif
             catch( exception e )
               msgbox( e.message + cr + "Errorcode: Trans2 (Line: " + e.lineno + ")" )
               return( "" )
             endtry
             if oQ.Rowset.fields["splitt"].value = true
                //than it was splitted...
                _app.translatorQ.rowset.indexname = ""
                oQ.Rowset.next(1)
                cRet+=&cRet
                _app.translatorQ.rowset.indexname = "allind"
             endif
             return( Iif( left( cRet.toUppercase( ),1 ) == "W"," "+trim( cRet ),trim( cRet  ) ) )
          ENDIF
      next    
   return( "" )
endclass
#endif //TFORM_H