/*
   File...: WshNetInfo.cc
   Author.: Rich Muller - AutoTraker.com
   Date...: August 25, 2003 turned into a .CC and added code 
            to optionally use runWait.prg program by Jim Sare 
            posted on the dBase.codeLib newsgroup in place 
            of use Windows Scripting Host

	This custom control will return 4 parameters parsed from a 
   text file created by Windows IPCONFIG program. Tested with 
   Windows ME and XP. No provisions were added for multiple 
   network cards.

   If you wish to use Jim Sare's runWait.prg instead of Windows 
   Scripting Host, when instantiating the object, pass a parameter
   of 'true', as in:
      set procedure to :dUFLP:WSHNetInfo.cc additive
      x = new WSH_Net_Info( true )
   any other value will use Windows Scripting Host.

   Example:
      set procedure to :dUFLP:WSHNetInfo.cc additive
      x = new WSH_Net_Info()
      ? "Host Name:        " + x.hostName
      ? "IP Address:       " + x.ipAddress
      ? "Subnet Mask:      " + x.subnetMask
      ? "Physical Address: " + x.macAddress
      release object x
      close procedure :dUFLP:WSHNetInfo.cc

   Paramaters: lRunWait -- use :dUFLP:RunWait.prg instead
                           of Windows Scripting Host.
*/

class WSH_Net_Info
   parameter lRunWait
   if type( "lRunWait" ) # "L"
      lRunWait = false
   endif
	store "" to this.hostName,this.ipAddress
   store "" to this.subnetMask,this.macaddress
   this.useRunWait = lRunWait
   this.init()

	function Init
      local tempName,sh,fso
      tempName = fUnique()
      if this.useRunWait
         set procedure to :dUFLP:runWait.prg additive
         RunWait(getEnv("COMSPEC")+" /c ipconfig /all > "+tempName,false,0xFFFFFFFF)
         close procedure :dUFLP:runWait.prg
		else
         sh = new OleAutoClient("wscript.shell")
         sh.run(getEnv("COMSPEC")+" /c ipconfig /all > "+tempName,0,true )
         release object sh
		endif
      fso = new file()
      fso.open(tempName)
      do while not fso.eof()
          data = ltrim(fso.gets())
          if "Host Name" $ data
            this.hostName = rtrim(substr(data,at(":",data)+2))
          endIf
          if "IP Address" $ data
            this.ipAddress = rtrim(substr(data,at(":",data)+2))
          endIf
          if "Subnet Mask" $ data
            this.subnetMask = rtrim(substr(data,at(":",data)+2))
          endIf
          if "Physical Address" $ data
            this.macAddress = rtrim(substr(data,at(":",data)+2))
          endIf
      enddo
      fso.close()
      fso.delete(tempName)
      release object fso
   return

endclass




